run_test.sh revision 3909
0N/A#!/bin/ksh -p
0N/A#
0N/A# Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
0N/A# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
0N/A#
0N/A# This code is free software; you can redistribute it and/or modify it
0N/A# under the terms of the GNU General Public License version 2 only, as
0N/A# published by the Free Software Foundation.
0N/A#
0N/A# This code is distributed in the hope that it will be useful, but WITHOUT
0N/A# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
0N/A# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
0N/A# version 2 for more details (a copy is included in the LICENSE file that
0N/A# accompanied this code).
0N/A#
0N/A# You should have received a copy of the GNU General Public License version
0N/A# 2 along with this work; if not, write to the Free Software Foundation,
0N/A# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
0N/A#
0N/A# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
0N/A# or visit www.oracle.com if you need additional information or have any
0N/A# questions.
0N/A#
0N/A
0N/A#
0N/A# @test
0N/A# @bug 6788096
0N/A# @summary Test simulates the case of multiple applets executed in
0N/A# the same VM and verifies that ImageIO shutdown hook
0N/A# StreamCloser does not cause a leak of classloaders.
0N/A#
0N/A# @build test.Main
0N/A# @build testapp.Main
0N/A# @run shell run_test.sh
0N/A
0N/A# There are several resources which need to be present before many
0N/A# shell scripts can run. Following are examples of how to check for
0N/A# many common ones.
0N/A#
0N/A# Note that the shell used is the Korn Shell, KSH
0N/A#
0N/A# Also note, it is recommended that make files NOT be used. Rather,
0N/A# put the individual commands directly into this file. That way,
0N/A# it is possible to use command line arguments and other shell tech-
0N/A# niques to find the compiler, etc on different systems. For example,
0N/A# a different path could be used depending on whether this were a
0N/A# Solaris or Win32 machine, which is more difficult (if even possible)
0N/A# in a make file.
0N/A
0N/A
0N/A# Beginning of subroutines:
0N/Astatus=1
0N/A
0N/A#Call this from anywhere to fail the test with an error message
0N/A# usage: fail "reason why the test failed"
0N/Afail()
0N/A { echo "The test failed :-("
0N/A echo "$*" 1>&2
0N/A echo "exit status was $status"
0N/A exit $status
0N/A } #end of fail()
0N/A
0N/A#Call this from anywhere to pass the test with a message
0N/A# usage: pass "reason why the test passed if applicable"
0N/Apass()
0N/A { echo "The test passed!!!"
0N/A echo "$*" 1>&2
0N/A exit 0
0N/A } #end of pass()
0N/A
0N/A# end of subroutines
0N/A
0N/A
0N/A# The beginning of the script proper
0N/A
0N/A# Checking for proper OS
0N/AOS=`uname -s`
0N/Acase "$OS" in
0N/A SunOS )
0N/A VAR="One value for Sun"
0N/A DEFAULT_JDK=/usr/local/java/jdk1.2/solaris
0N/A FILESEP="/"
0N/A PATHSEP=":"
0N/A TMP="/tmp"
0N/A ;;
0N/A
0N/A Linux )
0N/A VAR="A different value for Linux"
0N/A DEFAULT_JDK=/usr/local/java/jdk1.4/linux-i386
0N/A FILESEP="/"
0N/A PATHSEP=":"
0N/A TMP="/tmp"
0N/A ;;
0N/A
0N/A Windows_95 | Windows_98 | Windows_NT | Windows_ME | CYGWIN* )
0N/A VAR="A different value for Win32"
0N/A DEFAULT_JDK=/usr/local/java/jdk1.2/win32
0N/A FILESEP="\\"
0N/A PATHSEP=";"
0N/A TMP=`cd "${SystemRoot}/Temp"; echo ${PWD}`
0N/A ;;
0N/A
0N/A # catch all other OSs
0N/A * )
0N/A echo "Unrecognized system! $OS"
0N/A fail "Unrecognized system! $OS"
0N/A ;;
0N/Aesac
0N/A
0N/A# Want this test to run standalone as well as in the harness, so do the
0N/A# following to copy the test's directory into the harness's scratch directory
0N/A# and set all appropriate variables:
0N/A
0N/Aif [ -z "${TESTJAVA}" ] ; then
0N/A # TESTJAVA is not set, so the test is running stand-alone.
0N/A # TESTJAVA holds the path to the root directory of the build of the JDK
0N/A # to be tested. That is, any java files run explicitly in this shell
0N/A # should use TESTJAVA in the path to the java interpreter.
0N/A # So, we'll set this to the JDK spec'd on the command line. If none
0N/A # is given on the command line, tell the user that and use a cheesy
0N/A # default.
0N/A # THIS IS THE JDK BEING TESTED.
0N/A if [ -n "$1" ] ;
0N/A then TESTJAVA=$1
0N/A else echo "no JDK specified on command line so using default!"
0N/A TESTJAVA=$DEFAULT_JDK
0N/A fi
0N/A TESTSRC=.
0N/A TESTCLASSES=.
640N/A STANDALONE=1;
640N/Afi
640N/Aecho "JDK under test is: $TESTJAVA"
640N/A
640N/A
0N/A############### YOUR TEST CODE HERE!!!!!!! #############
0N/A
0N/A#All files required for the test should be in the same directory with
0N/A# this file. If converting a standalone test to run with the harness,
0N/A# as long as all files are in the same directory and it returns 0 for
0N/A# pass, you should be able to cut and paste it into here and it will
0N/A# run with the test harness.
0N/A
0N/A# This is an example of running something -- test
0N/A# The stuff below catches the exit status of test then passes or fails
0N/A# this shell test as appropriate ( 0 status is considered a pass here )
0N/A
0N/Aecho "Create TestApp.jar..."
0N/A
0N/Aif [ -f TestApp.jar ] ; then
0N/A rm -f TestApp.jar
0N/Afi
0N/A
0N/A${TESTJAVA}/bin/jar -cvf TestApp.jar -C ${TESTCLASSES} testapp
0N/A
0N/Aif [ $? -ne "0" ] ; then
0N/A fail "Failed to create TestApp.jar"
0N/Afi
0N/A
0N/Aecho "Create Test.jar..."
0N/Aif [ -f Test.jar ] ; then
0N/A rm -f Test.jar
0N/Afi
0N/A
0N/A${TESTJAVA}/bin/jar -cvf Test.jar -C ${TESTCLASSES} test
0N/A
0N/Aif [ $? -ne 0 ] ; then
0N/A fail "Failed to create Test.jar"
0N/Afi
640N/A
640N/A# Prepare temp dir for cahce files
640N/Amkdir ./tmp
640N/Aif [ $? -ne 0 ] ; then
640N/A fail "Unable to create temp directory."
640N/Afi
640N/A
640N/A# Verify that all classoladers are destroyed
640N/A${TESTJAVA}/bin/java -cp Test.jar test.Main
640N/Aif [ $? -ne 0 ] ; then
640N/A fail "Test FAILED: some classloaders weren't destroyed."
640N/Afi
640N/A
640N/A
640N/A# Verify that ImageIO shutdown hook works correcly
640N/A${TESTJAVA}/bin/java -cp Test.jar -DforgetSomeStreams=true test.Main
640N/Aif [ $? -ne 0 ] ; then
640N/A fail "Test FAILED: some classloaders weren't destroyed of shutdown hook failed."
640N/Afi
640N/A
814N/A# sanity check: verify that all cache files were deleted
814N/Acache_files=`ls tmp`
814N/A
814N/Aif [ "x${cache_files}" != "x" ] ; then
814N/A echo "WARNING: some cache files was not deleted: ${cache_files}"
814N/Afi
814N/A
814N/Aecho "Test done."
814N/A
814N/Astatus=$?
814N/A
814N/Aif [ $status -eq "0" ] ; then
814N/A pass ""
640N/Aelse
640N/A fail "Test failed due to test plugin was not found."
814N/Afi
640N/A
0N/A